var RegularEtcd = require('node-etcd');
var Q = require('q');

function Etcd(host, port, sslopts) {
  this.etcd = new RegularEtcd(host, port, sslopts);
}

Etcd.prototype.get = function (key, options) {
  return Q.ninvoke(this.etcd, 'get', key, options)
};

Etcd.prototype.set = function (key, value, options) {
  return Q.ninvoke(this.etcd, 'set', key, value, options)
};

Etcd.prototype.del = function (key, options) {
  return Q.ninvoke(this.etcd, 'del', key, options);
};

Etcd.prototype.mkdir = function (key) {
  return Q.ninvoke(this.etcd, 'mkdir', key);
};

Etcd.prototype.rmdir = function (key, options) {
  return Q.ninvoke(this.etcd, 'rmdir', key, options);
};

Etcd.prototype.watcher = function () {
  return this.etcd.watcher.apply(this.etcd, arguments);
};

Etcd.prototype.selfStats = function () {
  return Q.ninvoke(this.etcd, 'selfStats')
};

module.exports = Etcd;